package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.geotools.xml.xLink.XLinkSchema.From;

import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.service.BaseServlet;
import nc.bs.yp.plugin.GetBaseDAOUtil;
import nc.itf.uap.pf.IPFBusiAction;
import nc.log.NcLog;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.bd.material.MaterialVO;
import nc.vo.ct.saledaily.entity.AggCtSaleVO;
import nc.vo.ct.saledaily.entity.CtSaleBVO;
import nc.vo.ct.saledaily.entity.CtSaleChangeVO;
import nc.vo.ct.saledaily.entity.CtSaleExpVO;
import nc.vo.ct.saledaily.entity.CtSaleMemoraVO;
import nc.vo.ct.saledaily.entity.CtSaleTermVO;
import nc.vo.ct.saledaily.entity.CtSaleVO;
import nc.vo.ct.saledaily.entity.RecvPlanVO;
import nc.vo.org.DeptVO;
import nc.vo.org.GroupVO;
import nc.vo.org.SalesOrgVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.workflownote.WorkflownoteVO;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

public class ModifyMaintianImpl extends BaseServlet implements IHttpServletAdaptor{
	//Ψһʶ
	private String vbillcode = "";
	
	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSONObject.fromObject(createStr);
			NcLog.info("ۺͬJSON:"+json);
			vbillcode = json.getString("vbillcode");
			collect(json);
			resp.getWriter().write(formatRSJsonData("0",vbillcode,"").toString());
		} catch (Exception e) {
			//ǰ˿̨ӡxml
			resp.getWriter().write(formatRSJsonData("1",vbillcode,e.getMessage()).toString());
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info("ۺͬ:"+msg);
		}
		
	}

	public void collect(JSONObject json) throws Exception {
		
		//ͬ
		CtSaleTermVO ctSaleTermVO = new CtSaleTermVO();
		List<CtSaleTermVO> ctSaleTermListVO = new ArrayList<CtSaleTermVO>();
		//ͬ
		CtSaleExpVO ctSaleExpVO = new CtSaleExpVO();
		List<CtSaleExpVO> ctSaleExpListVO = new ArrayList<CtSaleExpVO>();
		//ͬ¼
		CtSaleMemoraVO ctSaleMemoraVO = new CtSaleMemoraVO();
		List<CtSaleMemoraVO> ctSaleMemoraListVO = new ArrayList<CtSaleMemoraVO>();
		//
     	GroupVO groupVo = GetBaseDAOUtil.getGroup(json.getString("groupCode"));
     	NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
     	
     	//߳ü
        InvocationInfoProxy.getInstance().setGroupId(groupVo.getPk_group());
     	//֯
        SalesOrgVO salesOrgVO = GetBaseDAOUtil.getSalesOrg(json.getString("pk_org"));
        String sm_userpk = GetBaseDAOUtil.getUser(json.getString("billmaker")).getCuserid();
        //û
        InvocationInfoProxy.getInstance().setUserId(sm_userpk);

		IMDPersistenceQueryService service=NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
		AggCtSaleVO aggCtSaleVO = (AggCtSaleVO) service.queryBillOfNCObjectByPKWithDR(AggCtSaleVO.class,GetBaseDAOUtil.GetVOID("ct_sale",json.getString("vbillcode")),true).getContainmentObject();
		//
		CtSaleVO ctSaleVO = aggCtSaleVO.getParentVO();
		//ƻЧ
		ctSaleVO.setValdate(new UFDate(json.getString("valdate")));
		//ƻֹ
		ctSaleVO.setInvallidate(new UFDate(json.getString("invallidate")));
		if(!"".equals(json.getString("depid"))) {
			DeptVO deptVO = GetBaseDAOUtil.getDept(json.getString("depid"),salesOrgVO.getPk_salesorg());
			//°汾
			ctSaleVO.setDepid(deptVO.getPk_dept());
			//
			ctSaleVO.setDepid_v(deptVO.getPk_vid());
		}
		
		//Ա
		ctSaleVO.setPersonnelid("".equals(json.getString("personnelid")) ? null :  GetBaseDAOUtil.getPsndoc(json.getString("personnelid"),salesOrgVO.getPk_salesorg()).getPk_psndoc());
		//vo״̬
		aggCtSaleVO.getParent().setStatus(1);
		
		
		//ʷ
		CtSaleChangeVO ctSaleChangeVO = new CtSaleChangeVO();
		//
		ctSaleChangeVO.setPk_ct_sale(aggCtSaleVO.getParent().getAttributeValue("pk_ct_sale").toString());
		//
		ctSaleChangeVO.setPk_group(groupVo.getPk_group());
		//֯°汾
		ctSaleChangeVO.setPk_org(salesOrgVO.getPk_org());
		//֯
		ctSaleChangeVO.setPk_org_v(salesOrgVO.getPk_vid());
		//汾+1
		ctSaleChangeVO.setVchangecode(new UFDouble(aggCtSaleVO.getChildren(CtSaleChangeVO.class).length+1));
		//
		ctSaleChangeVO.setVchgdate(new UFDate(json.getString("vchgdate")));
		//
		ctSaleChangeVO.setVchgpsn(sm_userpk);
		//ԭ
		ctSaleChangeVO.setVchgreason(json.getString("vchgreason"));
		//vo״̬
		ctSaleChangeVO.setStatus(2);
		
		
		JSONArray datas =  json.getJSONArray("ct_sale_b");
		for (int i = 0; i < datas.size(); i++) {
			JSONObject JSONBody = (JSONObject) datas.get(i);
			//ͬӱ
			CtSaleBVO ctSaleBVO = (CtSaleBVO) aggCtSaleVO.getChildren(CtSaleBVO.class)[i];
			//
			ctSaleBVO.setPk_group(groupVo.getPk_group());
			//֯°汾
			ctSaleBVO.setPk_org(salesOrgVO.getPk_org());
			//֯
			ctSaleBVO.setPk_org_v(salesOrgVO.getPk_vid());
			//к
			ctSaleBVO.setCrowno(JSONBody.getString("crowno"));
			MaterialVO materialVO = GetBaseDAOUtil.getMaterial(JSONBody.getString("pk_material"));
			//
			ctSaleBVO.setPk_material(materialVO.getPk_material());
			//°汾
			ctSaleBVO.setPk_srcmaterial(materialVO.getPk_source());
			//λ
			ctSaleBVO.setCastunitid("".equals(JSONBody.getString("castunitid")) ? null : GetBaseDAOUtil.getMeasdo(JSONBody.getString("castunitid")).getPk_measdoc());
			//λ
			ctSaleBVO.setCunitid("".equals(JSONBody.getString("cunitid")) ? null : GetBaseDAOUtil.getMeasdo(JSONBody.getString("cunitid")).getPk_measdoc());
			//
			ctSaleBVO.setVchangerate("1");
			//
			ctSaleBVO.setNastnum(new UFDouble(JSONBody.getString("nnum")));
			//
			ctSaleBVO.setNnum(new UFDouble(JSONBody.getString("nnum")));
			//˰
			ctSaleBVO.setNtaxrate(new UFDouble(JSONBody.getString("ntaxrate")));
			//λҺ˰
			ctSaleBVO.setNgtaxprice(new UFDouble(JSONBody.getString("norigtaxprice")));
			//˰
			ctSaleBVO.setNorigtaxprice(new UFDouble(JSONBody.getString("norigtaxprice")));
			//ۺ˰
			ctSaleBVO.setNqtorigtaxprice((new UFDouble(JSONBody.getString("norigtaxprice"))));
			//۱Һ˰
			ctSaleBVO.setNqttaxprice((new UFDouble(JSONBody.getString("norigtaxprice"))));
			//˰
			ctSaleBVO.setNmny((new UFDouble(JSONBody.getString("norigmny"))));
			//˰
			ctSaleBVO.setNorigmny((new UFDouble(JSONBody.getString("norigmny"))));
			//˰
			ctSaleBVO.setNtax((new UFDouble(JSONBody.getString("ntax"))));
			//ע
			ctSaleBVO.setVmemo(JSONBody.getString("vmemo"));
			//vo״̬
			ctSaleBVO.setStatus(1);
			
			aggCtSaleVO.getChildren(CtSaleBVO.class)[i] = ctSaleBVO;
		}
		
//		List<CtSaleBVO> ctSaleBListVOList = new ArrayList<CtSaleBVO>();
//		for (int i = 0; i < aggCtSaleVO.getChildren(CtSaleBVO.class).length; i++) {
//			//ͬӱ
//			CtSaleBVO ctSaleBVO = (CtSaleBVO) aggCtSaleVO.getChildren(CtSaleBVO.class)[i];
//			//
//			ctSaleBVO.setPk_group(groupVo.getPk_group());
//			//֯°汾
//			ctSaleBVO.setPk_org(salesOrgVO.getPk_org());
//			//֯
//			ctSaleBVO.setPk_org_v(salesOrgVO.getPk_vid());
//			//к
//			ctSaleBVO.setCrowno(crowno);
//			//
//			ctSaleBVO.setNnum(new UFDouble(2));
//			//vo״̬
//			ctSaleBVO.setStatus(1);
//			
//			aggCtSaleVO.getChildren(CtSaleBVO.class)[i] = ctSaleBVO;
//		}
		
		
		//鳤+1¼
		CtSaleChangeVO[] CtSaleChangearrVO = new CtSaleChangeVO[aggCtSaleVO.getChildren(CtSaleChangeVO.class).length+1];
		for (int i = 0; i < aggCtSaleVO.getChildren(CtSaleChangeVO.class).length; i++) {
			CtSaleChangearrVO[i] = (CtSaleChangeVO) aggCtSaleVO.getChildren(CtSaleChangeVO.class)[i];
		}
		CtSaleChangearrVO[CtSaleChangearrVO.length-1] = ctSaleChangeVO;
		aggCtSaleVO.setChildren(CtSaleChangeVO.class, CtSaleChangearrVO);
		processAction(aggCtSaleVO);
		
	}
	
	
	public void processAction(AggCtSaleVO aggCtSaleVO) throws Exception{
		WorkflownoteVO Workflownote = new WorkflownoteVO();
		IPFBusiAction ipf = NCLocator.getInstance().lookup(IPFBusiAction.class);
		//ñݶ
		ipf.processAction("MODIFY", "Z3", Workflownote, aggCtSaleVO, null, null);
	}
}
