package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.service.BaseServlet;
import nc.itf.mmpac.pickm.ppickm.IPpickmMaintainService;
import nc.itf.mmpac.pmo.pac0002.IPMOBusinessService;
import nc.itf.mmpac.pmo.pac0002.IPMOMaintainService;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.log.NcLog;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.mmpac.pickm.entity.AggPickmVO;
import nc.vo.mmpac.pmo.pac0002.entity.PMOAggVO;
import nc.yp.dao.PomStatusMaintain;
import net.sf.json.JSONObject;

/**
 * ޸Ŀ״̬
 * @author LP
 *
 */
@SuppressWarnings("restriction")
public class PomUpdateStatusImpl extends BaseServlet implements IHttpServletAdaptor {
	
	private static final String TURE = "0";
	private static final String FALSE = "1";
	private IMDPersistenceQueryService qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	private BaseDAO dao = new BaseDAO();
	private JSONObject p_data = null;

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
        InvocationInfoProxy.getInstance().setUserDataSource("syptest210103");
		
        String vbillcode = "";
        String errorMessgae = "";
        JSONObject logObject = new JSONObject();
        logObject.accumulate("InterName","޸Ŀ״̬");
		String json = buildJson(req, resp, this.getClass().getName());
		PrintWriter out = resp.getWriter();

		try {
			
			p_data = JSONObject.fromObject(json);//ȡ
			
			logObject.accumulate("InputData", p_data);
			
			vbillcode = p_data.getString("vbillcode");//ȡ
			
			checkJson();//ǿж
			
			PMOAggVO pmoAggVO = getPmoVO(vbillcode);//ȡAggVO
			
			InvocationInfoProxy.getInstance().setGroupId(SqlexecuteQuery("pk_group", "org_group", "code", p_data.getString("group")));
			InvocationInfoProxy.getInstance().setUserId(SqlexecuteQuery("cuserid", "sm_user", "user_code", p_data.getString("creator")));
			
			approveUpdate(pmoAggVO);//״̬
			
			out.print(formatRSJsonData(TURE, p_data.getString("vbillcode"), "ɹ"));
			logObject.accumulate("OutData", formatRSJsonData(TURE, p_data.getString("vbillcode"), "ɹ").toString());
			
		} catch (Exception e) {
			
			String error = e.getMessage()==null?e.toString():e.getMessage().toString();
			out.print(formatRSJsonData(FALSE, vbillcode, error));
			logObject.accumulate("OutData",formatRSJsonData(FALSE, vbillcode, error).toString());
			errorMessgae = StackTrace(e);
			
		}finally {
			NcLog.info(logObject.toString()+"\r"+errorMessgae);
			out.flush();
			out.close();
		}
		
	}
	
	/*
	 * ǿж
	 */
	private void checkJson() throws Exception {
		
		StringBuffer mags = new StringBuffer();
		
		String vbillcode = "vbillcode";//
		String statusName = "statusName";//״̬
		String group = "group";//ű
		String creator = "creator";//
 
		String[] HeadKey = {vbillcode,statusName,group,creator};
		
		for (String as : HeadKey) {

			if (p_data.getString(as).isEmpty()) {
				mags.append("'" + as + "'");
			}
		}
		
		if (mags.length()!=0) {
			throw new Exception("ֶβΪգ"+mags);
		}
	}
	
	/*
	 * ȡAggVO
	 */
	@SuppressWarnings("unchecked")
	private PMOAggVO getPmoVO(String vbillcode) throws Exception {
		
		ArrayList<PMOAggVO> PmoAggVOs = (ArrayList<PMOAggVO>) 
				qryService.queryBillOfVOByCond(PMOAggVO.class,"vbillcode = '"+vbillcode+"'",true,false);
		
		if (PmoAggVOs == null || PmoAggVOs.size() == 0) {
			throw new Exception("ݵݺ'"+vbillcode+"'δҵ飡");
		}else if (PmoAggVOs.get(0).getParentVO().getFbillstatus()==0 && p_data.getString("statusName").equals("ȡ")) {
			throw new Exception("'"+vbillcode+"'δ״̬飡");
		}else if (PmoAggVOs.get(0).getParentVO().getFbillstatus()==1 && p_data.getString("statusName").equals("")) {
			throw new Exception("'"+vbillcode+"'״̬飡");
		}else {
			PMOAggVO pmoAggVO = (PMOAggVO) PmoAggVOs.get(0).clone();
			return pmoAggVO;
		}
	}
	
	/*
	 * ȡϼƻAggVO
	 */
	@SuppressWarnings("unchecked")
	private AggPickmVO getPickmVO(String vfirstmocode) throws Exception {
		
		ArrayList<AggPickmVO> PickmAggVOs = (ArrayList<AggPickmVO>) 
				qryService.queryBillOfVOByCond(AggPickmVO.class,"vfirstmocode = '"+vfirstmocode+"'",true,false);

		AggPickmVO aggPickmVO = (AggPickmVO) PickmAggVOs.get(0).clone();
		return aggPickmVO;
	}
	
	/*
	 * ״̬
	 */
	private void approveUpdate(PMOAggVO pmoAggVO) throws Exception {
		
		String statusName = p_data.getString("statusName");
		PMOAggVO[] pmoAggVOs = new PMOAggVO[] {pmoAggVO};
		
		if (statusName.equals("")) {
			
			NCLocator.getInstance().lookup(IPMOMaintainService.class).approve(pmoAggVOs);
			
		}else if (statusName.equals("ȡ")) {
			
			AggPickmVO aggPickmVO = getPickmVO(p_data.getString("vbillcode"));
			AggPickmVO[] aggPickmVOs = new AggPickmVO[] {aggPickmVO};
			
//			NCLocator.getInstance().lookup(PomStatusMaintain.class).PomStatus_RequiresNew(aggPickmVO, pmoAggVO);
			
			if (aggPickmVO.getParentVO().getFbillstatus()==1) {
				NCLocator.getInstance().lookup(IPpickmMaintainService.class).unAuditPickm(aggPickmVOs);
			}
			NCLocator.getInstance().lookup(IPMOMaintainService.class).approveCancel(pmoAggVOs);
			
		}else if (statusName.equals("Ͷ")) {
			
			NCLocator.getInstance().lookup(IPMOBusinessService.class).put(pmoAggVOs);
			
		}else if (statusName.equals("ȡͶ")) {
			
			NCLocator.getInstance().lookup(IPMOBusinessService.class).putCancel(pmoAggVOs);
			
		}else if (statusName.equals("ǿ깤")) {
			
			NCLocator.getInstance().lookup(IPMOBusinessService.class).finish(pmoAggVOs);
			
		}else if (statusName.equals("ȡ깤")) {
			
			NCLocator.getInstance().lookup(IPMOBusinessService.class).finishCancel(pmoAggVOs);
			
		}else if (statusName.equals("ǿƹر")) {
			
			NCLocator.getInstance().lookup(IPMOBusinessService.class).close(pmoAggVOs);
			
		}else if (statusName.equals("ȡر")) {
			
			NCLocator.getInstance().lookup(IPMOBusinessService.class).closeCancel(pmoAggVOs);
			
		}
		else {
			throw new Exception("status ֻд ' ' 'ȡ' 'Ͷ''ȡͶ''ǿ깤''ȡ깤''ǿƹر'''ȡر','"+p_data.getString("statusName")+"'ĺϷԻʽǷȷ");
		}
		
	}
	
	/*
	 * 쳣Ϣϸ
	 */
	private String StackTrace(Exception e) {
	    StringWriter sw = new StringWriter();
	    PrintWriter pw = new PrintWriter(sw);
	    e.printStackTrace(pw);
	    return sw.toString();
	}
	
	/*
	 * ݿѯ
	 */
	private String SqlexecuteQuery(String out,String table,String key,String value) throws DAOException {
		
		String sql = "select "+out+" from "+table+" where "+key+" = '"+value+"' and nvl(dr,0)=0";
		
		Object object = dao.executeQuery(sql, new ColumnProcessor());
		
		if (object==null) {
			throw new DAOException("δѯݣ"+value+"Ƿȷ");
		}
		
		return object.toString();
		
	}
	
}
